#!/usr/bin/python
# -*- coding: utf-8 -*-

from setuphelpers import *
import time


uninstallkey = []

def install():
    for uninstall in installed_softwares('Mozilla Thunderbird'):
        if iswin64():
            if 'x86' in uninstall['name'] :
                print(u'remove Thunderbird x86 for install Thunderbird x64' )
                if uninstall_key_exists(uninstall['key']):
                    killalltasks('thunderbird.exe')
                    run(uninstall_cmd(uninstall['key']))
                    time.sleep (5)

    version = control['version'].split('-',1)[0]
    key='Mozilla Thunderbird %s (%s %s)' % (version,control.architecture,control.locale)
    install_exe_if_needed('Thunderbird Setup %s.exe' % version ,silentflags='-ms',key=key ,min_version=version,killbefore=['thunderbird.exe'])
    remove_desktop_shortcut('Mozilla Thunderbird')

    registry_set(HKEY_LOCAL_MACHINE,'SOFTWARE\\Policies\\Mozilla\\Thunderbird','DisableAppUpdate',1,REG_DWORD)

    for mms in installed_softwares('MozillaMaintenanceService'):
        if uninstall_key_exists(mms['key']):
            run(uninstall_cmd(mms['key']))


def update_package():
    import re,requests,glob
    arch = {'x86':'win','x64':'win64'}

    url = requests.head('https://download.mozilla.org/?product=thunderbird-latest&os=%s&lang=%s' % ((arch[control.architecture]),control.locale)).headers['Location']
    filename = url.rsplit('/',1)[1].replace('%20',' ')
    if not isfile(filename):
        print('Downloading %s from %s'%(filename,url))
        wget(url,filename)
    else:
        print(filename + ' already exist')


    # updates control version from filename, increment package version.
    control.version = '%s-10'%(re.findall(r'Thunderbird Setup (.*)\.exe',filename)[0])
    control.save_control_to_wapt()

    # removes old exe
    if isfile(filename):
        exes = glob.glob('Thunderbird*.exe')
        for fn in exes:
            if fn != filename:
                print('Delete ' + fn)
                remove_file(fn)

    print('The update is complete, you can now test and then launch a build upload.')

def session_setup():

    listlnk = []
    try:
        listlnk.extend(find_all_files(makepath(user_appdata(),'Microsoft','Internet Explorer','Quick Launch', 'User Pinned'),'*.lnk'))
    except:
        pass
    try:
        listlnk.extend(glob.glob(makepath(user_desktop(),'*.lnk')))
    except:
        pass
    try:
        listlnk.extend(find_all_files(winshell.programs(0),'*.lnk'))
    except:
        pass
    try:
        listlnk.extend(find_all_files(makepath(user_appdata(),'ClassicShell', 'Pinned'),'*.lnk'))
    except:
        pass

    #Fix missing shortcut if path not found
    exe = makepath(installed_softwares('Mozilla Thunderbird')[0]['install_location'],'thunderbird.exe')
    for lnk in listlnk :
        try:
            if get_shortcut_properties(lnk)['path'].lower().endswith('thunderbird.exe'):
                if isfile(get_shortcut_properties(lnk)['path'].lower()):
                    continue
                arg = get_shortcut_properties(lnk)['arguments']
                remove_file(lnk)
                create_shortcut(lnk,exe,arguments=arg)
        except:
            pass

if __name__ == '__main__':
    update_package()

